    abonent = "abonent"

    declare zone[11]
    declare net[11]
    declare node[11]
    declare point[11]

    inbound = .F.
    interval = 0
    download = 0
    upload = 0
    ratio = 0

    clear screen

    use &abonent index aizone index ainet index ainode index aipoint

    lun = FOPEN("MNSTAT.DAT",0)

    do while (RxRecord(lun))
        select A
        for i = 1 to 11
            if(.not.(zone[i]=0))
                *
                *    ⮬ AKA
                *
                locate for (a_zone = zone[i]).and.(a_net = net[i]).and.(a_node = node[i]).and.(a_point = point[i])
                if(found())             &&    ⮩ 

                    if(inbound)         && 室騩 
                        replace a_in_ul with a_in_ul+upload
                        replace a_in_dl with a_in_dl+download
                        replace a_debit with a_debit+(a_costcall*interval)
                    else                && 室騩 
                        replace a_out_ul with a_out_ul+upload
                        replace a_out_dl with a_out_dl+download
                        replace a_credit with a_credit-(a_costcall*interval)
                    endif

                    replace a_credit with a_credit-(upload*a_costdata/1024)
                    replace a_debit with a_debit+(download*a_costdata/1024)

                    ? "Abonent "+address(i)
                    ? "Sysop "+a_name
                    ? "Session time ="+str(interval,0)
                    ? "Upload = "+str(upload,0)
                    ? "Download = "+str(download,0)
                    ?
                endif
            endif
        next
    enddo

    FCLOSE(lun)

    return
*
* ନ஢ ᭮ ப
*
function address
    parameters i

    s = ltrim(str(zone[i],0))+":"+ltrim(str(net[i],0))+"/"+ltrim(str(node[i],0))+"."+ltrim(str(point[i],0))

    return s
*
* ଠ  :
*
* 000 1      - ਧ Inbound
* 001 2     -  ᨨ  
* 007 11*8   -  㤠 ⥬
* 095 4     - - ਭ  ⥬ ⮢
* 099 4     - - । ⥬ 
*
*   99 .
*
function RxRecord
    parameters lun
    private buf,i

    buf = space(100)

    if(.not.(FREAD(lun,@buf,99) = 99))
        return .F.
    endif

    if(asc(substr(buf,1,1)) = 1)
        inbound = .T.
    else
        inbound = .F.
    endif

    interval = atoi(substr(buf,2,2))

    for i = 1 to 11
        zone[i]  = atoi(substr(buf,4 + (i-1)*8,2))
        net[i]   = atoi(substr(buf,6 + (i-1)*8,2))
        node[i]  = atoi(substr(buf,8 + (i-1)*8,2))
        point[i] = atoi(substr(buf,10 + (i-1)*8,2))
    next

    download = atol(substr(buf,92,4))
    upload   = atol(substr(buf,96,4))

    return .T.
*
*
*
function atoi
    parameters s

    return(asc(s) + asc(substr(s,2,1))*256)
*
*
*
function atol
    parameters s

    return(asc(s) + asc(substr(s,2,1))*256 + asc(substr(s,3,1))*65536 + asc(substr(s,4,1))*16777216)

