#ifndef __MNSTAT_H
#define __MNSTAT_H

/*            ****    ᠭ  䠩 MNSTAT.DAT    ***            */
/*                                                                          */
/*     MnStat.dat ᮧ  ⮩ ४ਨ,  ன 室  - */
/* 室 *.LOG - 䠩.  ᫨  ⮩ ४ਨ 䠩  ⠪  㦥 - */
/* ,  ᫥ ଠ 뢠   ⮣ 䠩.    */
/*       䠩  MnStat.dat  뢠 ன  SAVESTAT  */
/* ᮤন ଠ   ᯥ譮 ஢ ⮢ ᨨ.        */
/*     ⫨稨  䠩 inbound.his  outbound.his  䠩 MnStat.dat - */
/* 뢠  AKA, ।⠢ 㤠 ⥬,   ⮬  */
/*  ᥣ      ᬥ饭  ᨢ Remote ࠢ . */
/* ⠫   ᨢ Remote ।⠢  AKA  㤠 ⥬, */
/*  ⮬ ᨢ 稭     ᮬ 1.  ᯮ- */
/* 㥬  ᨢ   Zone ࠢ .                  */


#define VERSION 2                       /*  ᭮ ᨨ ணࠬ */
#define CORRECTION 1                    /*  ४樨 ணࠬ */

/*   ᭮ ଠ樨 */
struct ADDRESS
    {
    unsigned int Zone;                  /*  */
    unsigned int Net;                   /*  */
    unsigned int Node;                  /*  */
    unsigned int Point;                 /* 窠 */
    } ;

/*   ଠ樨  Upload  Download */
struct COUNTER
    {
    unsigned long Download;             /* ਭ  ଠ樨 */
    unsigned long Upload;               /* ।  ଠ樨 */
    } ;

/*    䠩 MnStat.dat */
struct SAVESTAT
    {
    unsigned char IsInbound;            /* 0 -  , 1 -   */
    unsigned int Interval;              /* ६  裡,  */
    struct ADDRESS Remote[11];          /*  㤠 ⥬ */
    struct COUNTER Counter;             /* UL/DL 稪 */
    } StatArea;

#endif
